routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

/**
 * All Admin Group Route 
*/
Route::group(['as' => 'admin.', 'prefix' => 'admin', 'namespace' => 'Admin'],  function() {
    // Admin Login and Logout
    Route::get('/login', 'Auth\LoginController@showLoginForm')->name('login'); 
    Route::post('/login', 'Auth\LoginController@login')->name('login.submit');
    Route::post('/logout', 'Auth\LoginController@adminLogout')->name('logout');
    // End 
    // Admin Dashboard
    Route::get('/', 'AdminController@index')->name('dashboard');
    // End 
    // Admin Profile
    Route::match(['get', 'patch'], '/profile','AdminController@profile')->name('profile');
    // End
    //Admin Setting 
    Route::get('setting/','SettingController@general')->name('setting');
    Route::get('setting/general/','SettingController@general')->name('setting.general');
    Route::get('setting/under-construction','SettingController@underConstruction')->name('setting.underconstruction');
    Route::post('setting/save/general','SettingController@save')->name('setting.general.save');
    Route::post('setting/save/underconstruction','SettingController@save')->name('setting.underconstruction.save');
    Route::get('setting/miscellaneous','SettingController@miscellaneous')->name('setting.miscellaneous');
    Route::post('setting/save/miscellaneous','SettingController@save')->name('setting.miscellaneous.save');
    //End

    // Media 
    Route::get('media/','MediaController@index')->name('media');
    Route::get('media/create','MediaController@create')->name('media.create');
    Route::post('media/store','MediaController@store')->name('media.store');
    Route::post('media/ckeditor','MediaController@ckditor_store')->name('media.ckeditor');
    Route::get('media/ckbrowse','MediaController@ckbrowse')->name('media.ckbrowse');
    Route::get('media/delete/{id}','MediaController@destroy')->name('media.delete');
    Route::post('media/delete-all','MediaController@deleteall')->name('media.delete.all');
    // end

    // Pages 
    Route::get('pages/','PageController@index')->name('pages');
    Route::get('page/create','PageController@create')->name('pages.create');
    Route::post('page/save','PageController@store')->name('pages.save');
    Route::get('page/edit/{id}','PageController@edit')->name('pages.edit');
    Route::post('page/update/{id}','PageController@update')->name('pages.update');
    Route::get('page/delete/{id}','PageController@destroy')->name('pages.delete');
    // End
    /**
     * Posts
     */
    Route::get('posts/','PostController@index')->name('posts');
    Route::get('post/create','PostController@create')->name('posts.create');
    Route::post('post/save','PostController@store')->name('posts.save');
    Route::get('post/edit/{id}','PostController@edit')->name('posts.edit');
    Route::post('post/update/{id}','PostController@update')->name('posts.update');
    Route::get('post/delete/{id}','PostController@destroy')->name('posts.delete');
    /**
     * End 
     */
    /**
     * Category
     */
    Route::get('categories/','CategoryController@index')->name('categories');
    Route::post('category/save','CategoryController@store')->name('categories.save');
    Route::get('category/edit/{id}','CategoryController@edit')->name('categories.edit');
    Route::post('category/update/{id}','CategoryController@update')->name('categories.update');
    Route::get('category/delete/{id}','CategoryController@destroy')->name('categories.delete');
    /**
     * End 
     */
    /**
     * Tags
     */
    Route::get('tags/','TagController@index')->name('tags');
    Route::post('tag/save','TagController@store')->name('tags.save');
    Route::get('tag/delete/{id}','TagController@destroy')->name('tags.delete');
    Route::get('tag/status/{id}','TagController@status')->name('tags.status');
    Route::post('tag/ajax','TagController@ajax')->name('tags.ajax');
    /**
     * End 
     */
    /**
     * Menus
     */
    Route::get('menus/','MenuController@index')->name('menus');
    Route::post('menu/save','MenuController@store')->name('menus.save');
    Route::get('menu/status/{id}','MenuController@status')->name('menus.status');
    Route::get('menu/edit/{id}','MenuController@edit')->name('menus.edit');
    Route::post('menu/update/{id}','MenuController@update')->name('menus.update');
    Route::get('menu/add-items/{id}','MenuController@addItem')->name('menus.additems');
    Route::post('menu/getdetails','MenuController@getMenuDetails')->name('menus.getdetail');
    Route::post('menu/items/save','MenuController@saveMenuItems')->name('menus.items.save');
    Route::get('menu/delete/{id}','MenuController@destroy')->name('menus.delete');
    /**
     * End 
     */

    /**
     * Admin User
     */
    Route::get('admin-users','AdminUsers@index')->name('adminusers');
    Route::get('admin-user/create','AdminUsers@create')->name('adminuser.create');
    Route::post('admin-user/save','AdminUsers@store')->name('adminuser.store');
    Route::get('admin-user/edit/{id}','AdminUsers@edit')->name('adminuser.edit');
    Route::post('admin-user/update/{id}','AdminUsers@update')->name('adminuser.update');
    Route::post('admin-user/special-permission/{id}','AdminUsers@specialPermission')->name('adminuser.special.permission');
    /**
     * End
     */
    /**
     * User
     */
    Route::get('users','UserController@index')->name('users');
    Route::get('user/create','UserController@create')->name('users.create');
    Route::post('user/store','UserController@store')->name('users.save');
    Route::get('user/edit/{id}','UserController@edit')->name('users.edit');
    Route::post('user/update/{id}','UserController@update')->name('users.update');
    /**
     * End
     */
    /**
     * Role
     */
    Route::get('roles','RoleController@index')->name('roles');
    Route::post('role/save','RoleController@store')->name('role.save');
    Route::get('role/edit/{id}','RoleController@edit')->name('role.edit');
    Route::post('role/update/{id}','RoleController@update')->name('role.update');
    Route::get('role/delete/{id}','RoleController@destroy')->name('role.delete');
    Route::post('role-add-to-permissions/{id}','RoleController@addRoleToPermissions')->name('roleToPermissions');
    /**
     * End 
     */
    /**
     * Permissions
     */
    Route::get('permissions','PermissionController@index')->name('permissions');
    Route::post('permission/save','PermissionController@store')->name('permission.save');
    Route::get('permission/edit/{id}','PermissionController@edit')->name('permission.edit');
    Route::post('permission/update/{id}','PermissionController@update')->name('permission.update');
    Route::get('permission/delete/{id}','PermissionController@destroy')->name('permission.delete');
    Route::post('permission-add-to-roles/{id}','PermissionController@addPermissionToRoles')->name('permissionToroles');
});
/**
 * End of Admin route
 */

// Route::get('/', function () {
//    dd();
// });
Route::get('/', 'PageController@index')->name('home-page');
// Route::get('/test', function () {
    
//     $a = Auth::guard('admin')->user();
//     $r = Userdata::get($a,'test');
//     dd($r);
// });
// Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Category.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\CustomTraits\SeoMetaElements;
use App\CustomTraits\MediaTrait;
class Category extends Model
{
    use SeoMetaElements,MediaTrait;
    protected $fillable = ['name','parent','slug','status','content','image_id','mobile_image_id'];

    /**
     * Get The owning posts
     */
    public function posts()
    {
        return $this->morphedByMany('App\Post', 'post_category_relationships');
    }

}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\Http\Requests\CategoryRequest;
use App\Category;
use Slug;
use Seo;
use DB;
use Validator;
class CategoryController extends Controller
{
    private $parent=array();

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->parent[0]='No Parent';
        $parent_cat = Category::where(['status'=>1])->get();

        foreach($parent_cat  as $key => $cat)
        {
            $this->parent[$cat->id] = $cat->name;
        }


        $this->middleware('auth:admin');
        $this->middleware('permission:list.category',['only'=>['index']]);
        $this->middleware('permission:store.category',['only'=>'store']);
        $this->middleware('permission:edit.category',['only'=>'edit']);
        $this->middleware('permission:update.category',['only'=>'update']);
        $this->middleware('permission:delete.category',['only'=>'destroy']);
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $parent = $this->parent;
        $categories = Category::all();
        return view('admin.categories.list',compact('parent','categories'));
    }

    /**
     * Show the form for creating a new resource. 
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(CategoryRequest $request)
    {

        
        if($request->ajax())
        {
            $validator = Validator::make($request->all(), [
                'name'=>'required'
            ]);
            
            if($validator->fails())
            {
                
                    return response()->json(array(
                        'success' => false,
                        'errors' => $validator->getMessageBag()->toArray()
                
                    ), 200); // 400 being the HTTP code for an invalid request.
                
            }
            $inputs['name']=$request->name;
            $inputs['parent']=$request->parent;
            $inputs['status']=1;
            $inputs['slug']=Slug::createCategorySlug($request->name,$request->parent);
            $result = Category::create($inputs);
            $result->meta_element()->create(['seo_title'=>$request->name]);
            if($result)
            {
                return response()->json(array('status'=>true,'id'=>$result->id,'name'=>$result->name));
            }
            else
            {
                return response()->json(array('id'=>$result->id,'name'=>$result->name));
            }
        }
        else
        {
            $inputs['name']=$request->name;
            $inputs['parent']=$request->parent;
            $inputs['status']=1;
            $inputs['slug']=Slug::createCategorySlug($request->name,$request->parent);

            $result = Category::create($inputs);
            $result->meta_element()->create(['seo_title'=>$request->name]);
            if($result)
            {
                return redirect()->route('admin.categories')
                        ->with('success','Category created successfully.');
            }
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $parent = $this->parent;

        unset($parent[$id]);
        $category = Category::find($id);
        if($category)
        {
            $remove = Category::find($id)->pluck('name', 'id')->toArray();

            return view('admin.categories.edit',compact('category','parent'));
        }
        else
        {
            return redirect()->route('admin.categories')
                    ->with('error',$id. ' category id is not exist');
        }

    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(CategoryRequest $request, $id)
    {

        $category= Category::find($id);
        $inputs['name']=$request->name;
        $inputs['parent']=$request->parent;
        $inputs['status']=$request->status;
        $inputs['content']=$request->content;
        if($category->parent != $request->parent)
        {
            $inputs['slug']=Slug::createCategorySlug($request->name,$request->parent,$id);
        }


        $result = $category->update($inputs);

        if($result)
        {
            Seo::updateElement($category ,$request);
            return redirect()->route('admin.categories.edit',$id)
                    ->with('success','Category edited successfully.');
        }


    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $cat = Category::find($id);
        $cat->posts()->detach();
        $cat->meta_element()->delete();
        $cat->media()->detach();
        $result = Category::destroy($id);
        if($result )
        {
            return redirect()->route('admin.categories')
                            ->with('success','Category deleted successfully.');
        }
    }
}

resources/views/admin/categories/edit.blade.php
@extends('layouts.master')
@section('title') Edit Category @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Edit Category') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ url('admin') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <a href="{{ route('admin.categories') }}">
                    <span>{{ __('Categories') }}</span>
                </a>
            </li>
            <li>
                <span>{{ __('Edit Category') }}</span>
            </li>
            
        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>
</header>

    {!! Form::model($category, ['method' => 'POST','route' => ['admin.categories.update', $category->id]]) !!}
    <div class="col-sm-9">
        <section class="panel">
            <header class="panel-heading">
                <div class="panel-actions">
                    <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                    
                </div>
        
                <h2 class="panel-title">{{ __('Edit Category') }}</h2>
            </header>
            <div class="panel-body">
                <div class="form-group @error('name') has-error @enderror">
                    {{ Form::label('name', 'Name') }}
                    
                    {{ Form::text('name',$category->name,array('id'=>'name','placeholder'=>'','class'=>'form-control')) }}
                    @error('name')
                        <label id="name-error" class="error" >{{ $message }}</label>
                    @enderror 
                </div>
                <div class="form-group">
                    {{ Form::label('content', 'Content') }}
                    {!! Form::textarea('content', $category->descriptions, ['class' => 'post_content','id'=>'content']) !!}
                </div>
            </div>
        </section>
        <section class="panel">
            <header class="panel-heading">
                <div class="panel-actions">
                    <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                    
                </div>
        
                <h2 class="panel-title">{{  __('Seo Meta Details')}}</h2>
            </header>
            <div class="panel-body">
                {!! Seo::getElements($category) !!}
            </div>
        </section>
    </div>
    <div class="col-sm-3">
        <section class="panel">
            <header class="panel-heading">
                <div class="panel-actions">
                    <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                    
                </div>
        
                <h2 class="panel-title">{{ __('Attributes') }}</h2>
            </header>
            <div class="panel-body">
                <div class=" form-group">
                    {{ Form::label('parent', 'Parent', array('class' => 'control-label')) }}
                    {!! Form::select('parent',$parent,$category->parent,array('class'=>'form-control'))!!}
                </div>
                <div class=" form-group">
                    {{ Form::label('status', 'Stutus', array('class' => 'control-label')) }}
                    {!! Form::select('status',array(1=>'Publish',0=>'Draft'),$category->status,array('class'=>'form-control'))!!}
                </div>
                <div class="form-group">
                    <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Update') }}">
                </div>
            </div>
        </section>
    </div>
    {{ Form::close() }}

@endsection

@push('jsvender')
    <script src="{{ asset('admin-design/ckeditor/ckeditor.js') }}"></script>
@endpush
@push('adminjs')
    <script>
        $(document).ready(function(){
                if($('#content').length > 0){
            CKEDITOR.replace( 'content', {
                filebrowserUploadUrl: "{{route('admin.media.ckeditor', ['_token' => csrf_token() ])}}",
                filebrowserUploadMethod: 'form',
                filebrowserBrowseUrl:"{{route('admin.media.ckbrowse', ['_token' => csrf_token() ])}}"
            });
            CKEDITOR.on('dialogDefinition', function (ev) {
                var dialogName = ev.data.name;
                var dialogDefinition = ev.data.definition;
                
                if (dialogName == 'image') {
                    var onOk = dialogDefinition.onOk;
                    dialogDefinition.onOk=function(e){
                        var input = this.getContentElement( 'info', 'txtUrl' ),
                        imageSrcUrl = input.getValue();
                        //! Manipulate imageSrcUrl and set it
                        input.setValue( imageSrcUrl );
                        onOk && onOk.apply( this, e );
                        
                    }
                }
                });
                }
            });
    </script>

    @if ($message = Session::get('success'))
        <script>
            new PNotify({
                    title: 'Category',
                    text: '{{ $message }}',
                    type: 'success'
                });
        </script>
    @endif
@endpush

resources/views/admin/categories/list.blade.php
@extends('layouts.master')
@section('title') Categories @endsection
@section('content')
<header class="page-header">
    <h2>{{ __('Categories') }}</h2>

    <div class="right-wrapper pull-right">
        <ol class="breadcrumbs">
            <li>
                <a href="{{ url('admin') }}">
                    <i class="fa fa-home"></i>
                </a>
            </li>
            <li>
                <span>{{ __('Categories') }}</span>
            </li>
            
        </ol>

        <a class="sidebar-right-toggle" ></a>
    </div>
</header>
<div class="col-sm-12">
<section class="panel">
    <header class="panel-heading">
        <div class="panel-actions">
            <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
            
        </div>

        <h2 class="panel-title">{{ __('Add Category') }}</h2>
    </header>
    <div class="panel-body">
        {{  Form::open(array('route' => 'admin.categories.save','method' => 'POST','files'=> true))}}
        <div class="form-group @error('name') has-error @enderror">
            {{ Form::label('name', 'Name') }}
            
            {{ Form::text('name',null,array('id'=>'name','placeholder'=>'','class'=>'form-control')) }}
            @error('name')
                <label id="name" class="error" >{{ $message }}</label>
            @enderror 
        </div>
        <div class=" form-group">
            {{ Form::label('parent', 'Parent', array('class' => 'control-label')) }}
            {!! Form::select('parent',$parent,null,array('class'=>'form-control'))!!}
        </div>
        <div class="form-group">
            <input type="submit" class="mb-xs mt-xs mr-xs btn btn-primary" value="{{ __('Add') }}">
        </div>
        {{ Form::close() }}
    </div>
</section>
</div>
<div class="col-sm-12">
    <section class="panel">
        <header class="panel-heading">
            <div class="panel-actions">
                <a href="#" class="panel-action panel-action-toggle" data-panel-toggle=""></a>
                
            </div>
    
            <h2 class="panel-title">{{ __('Categories') }}</h2>
        </header>
        <div class="panel-body">
            <table class="table table-bordered table-striped mb-none" id="datatable-default">
                <thead>
                    <tr>
                        <th>Sl</th>
                        <th>Title</th>
                        <th>Slug</th>
                        <th>Status</th>
                        
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @php ($i = 1)  
                    @foreach ($categories as $key =>$cat)
                    <tr>
                        <td>{{ $i++ }}</td>
                        <td>{{ $cat->name }}</td>
                        <td>{{ $cat->slug }}</td>
                        <td>@if($cat->status == '1')
                            {{__('publish')}}
                        @else
                            {{__('draft')}}
                        @endif

                        </td>
                        <td>
                            <a href="{{ route('admin.categories.edit',$cat->id) }}"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></a>
                            @if ($cat->id != 1)
                            
                            <a href="{{ route('admin.categories.delete',$cat->id) }}" onclick="return confirm('Are you sure you want delete ?');"><i class="fa fa-trash-o" aria-hidden="true"></i></a>  

                            @endif
                            
                        </td>
                    </tr>   
                    @endforeach
                    
                    
                </tbody>
            </table>
        </div>
    </section>
</div>
@endsection
@push('cssvender')
    <link rel="stylesheet" href="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/css/datatables.css')}}" />
@endpush

@push('jsvender')
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables/media/js/jquery.dataTables.js')}}"></script>
	<script src="{{ asset('admin-design/assets/vendor/jquery-datatables/extras/TableTools/js/dataTables.tableTools.min.js')}}"></script>
    <script src="{{ asset('admin-design/assets/vendor/jquery-datatables-bs3/assets/js/datatables.js')}}"></script>
@endpush
@push('adminjs')
<script src="{{ asset('admin-design/assets/javascripts/tables/examples.datatables.default.js')}}"></script>
    @if ($message = Session::get('success'))
        <script>
            new PNotify({
                    title: 'Category',
                    text: '{{ $message }}',
                    type: 'success'
                });
        </script>
    @endif
    @if ($message = Session::get('error'))
        <script>
            new PNotify({
                    title: 'Category',
                    text: '{{ $message }}',
                    type: 'error'
                });
        </script>
    @endif
@endpush